import { DataColumn, FilterSet, SortDirection, ColumnFilterType, Comparator } from 'philo-search-core';
declare const _sfc_main: import("vue").DefineComponent<{
    tableId: {
        type: StringConstructor;
        required: false;
    };
    theme: {
        type: StringConstructor;
        required: false;
    };
    bindToQueryString: {
        type: BooleanConstructor;
        required: false;
    };
    sort: {
        type: StringConstructor;
        required: false;
    };
    sortDir: {
        type: null;
        required: false;
    };
    page: {
        type: NumberConstructor;
        required: false;
    };
    pageSize: {
        type: NumberConstructor;
        required: false;
    };
    columns: {
        type: ArrayConstructor;
        required: true;
    };
    fetchRequired: {
        type: BooleanConstructor;
        required: true;
    };
    filterOpen: {
        type: BooleanConstructor;
        required: true;
    };
    focusFilterOnOpen: {
        type: StringConstructor;
        required: true;
    };
    fetchRows: {
        type: FunctionConstructor;
        required: true;
    };
}, {
    props: {
        tableId?: string | undefined;
        theme?: string | undefined;
        bindToQueryString?: boolean | undefined;
        sort?: string | undefined;
        sortDir?: SortDirection | undefined;
        page?: number | undefined;
        pageSize?: number | undefined;
        columns: Array<DataColumn>;
        fetchRequired: boolean;
        filterOpen: boolean;
        focusFilterOnOpen: string;
        fetchRows: (filter: FilterSet) => Promise<{
            rows: Array<any>;
            totalRowCount: number;
        }>;
    };
    emit: (event: 'fetchRequired', req: boolean) => void;
    processor: import("vue").Ref<{
        columns: {
            field: string;
            label: string;
            visible: boolean;
            nullable?: boolean | undefined;
            filter?: {
                type: ColumnFilterType;
                action: Comparator;
                visible: boolean;
                defaultValues: string | string[];
                props?: {
                    [x: string]: string;
                } | undefined;
                options?: {
                    label: string;
                    value: string;
                }[] | undefined;
            } | undefined;
        }[];
        requiredFilters: {
            field: string;
            type: ColumnFilterType;
            nullable?: boolean | undefined;
            value: import("philo-search-core/lib/datastructure").ColumnFilterValue;
            action: Comparator;
        }[];
        page: number;
        pageSize: number;
        sortBy?: string | undefined;
        sortDir: SortDirection;
        columnFilters: {
            id: string;
            field: string;
            label: string;
            type: ColumnFilterType;
            value?: string | string[] | undefined;
            action: Comparator;
            nullable: boolean;
            props: {
                [x: string]: string;
            };
            options?: {
                label: string;
                value: string;
            }[] | undefined;
        }[];
        setSort: (sortBy: string, sortDir: SortDirection) => void;
        setPagination: (page: number, pageSize: number) => void;
        doTextSearch: (query: string) => FilterSet;
        doSearch: () => FilterSet;
        buildColumnFilters: () => void;
    }>;
    rows: import("vue").Ref<any[]>;
    showFilter: import("vue").Ref<boolean>;
    toggleFilterShow: (val?: boolean | undefined) => void;
    cols: import("vue").ComputedRef<{
        field: string;
        label: string;
        visible: boolean;
        nullable?: boolean | undefined;
        filter?: {
            type: ColumnFilterType;
            action: Comparator;
            visible: boolean;
            defaultValues: string | string[];
            props?: {
                [x: string]: string;
            } | undefined;
            options?: {
                label: string;
                value: string;
            }[] | undefined;
        } | undefined;
    }[]>;
    pagination: import("vue").Ref<{
        page: number | undefined;
        per_page: number | undefined;
        total: number;
    }>;
    hasMounted: import("vue").Ref<boolean>;
    fetchingData: import("vue").Ref<boolean>;
    loadData: (query: {
        page: number;
        per_page: number | string;
    }) => Promise<void>;
    loadDataWithLastQuery: () => Promise<void>;
    requestDataLoad: () => void;
    routerLocator: (() => import("vue-router").Router) | undefined;
    router: import("vue-router").Router | undefined;
    routeLocator: (() => import("vue-router").RouteLocationNormalizedLoaded) | undefined;
    route: import("vue-router").RouteLocationNormalizedLoaded | undefined;
    populateFiltersFromQuery: () => Promise<boolean | undefined>;
    hasBeenUnmounted: import("vue").Ref<boolean>;
    filterChanged: (filter: FilterSet) => Promise<boolean>;
    themes: {
        bootstrap: {
            row: string;
            col: string;
        };
        vuetify: {
            row: string;
            col: string;
            colAuto: string;
            tiny: string;
            max: string;
        };
    };
    rowClass: import("vue").ComputedRef<string>;
    colClass: import("vue").ComputedRef<string>;
    colClassAuto: import("vue").ComputedRef<string>;
    colClassMax: import("vue").ComputedRef<string>;
    btnClass: import("vue").ComputedRef<"btn btn-outline-primary" | "v-btn" | "t-btn">;
    columnFilterType: typeof ColumnFilterType;
    asBool: (val: string) => boolean;
    setSort: (para: {
        column: DataColumn;
        sortDir: SortDirection;
    }) => Promise<void>;
    DataTable: import("vue").DefineComponent<unknown, object, {}, import("vue").ComputedOptions, import("vue").MethodOptions, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<unknown>, {}>;
}, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, "fetchRequired"[], "fetchRequired", import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
    tableId: {
        type: StringConstructor;
        required: false;
    };
    theme: {
        type: StringConstructor;
        required: false;
    };
    bindToQueryString: {
        type: BooleanConstructor;
        required: false;
    };
    sort: {
        type: StringConstructor;
        required: false;
    };
    sortDir: {
        type: null;
        required: false;
    };
    page: {
        type: NumberConstructor;
        required: false;
    };
    pageSize: {
        type: NumberConstructor;
        required: false;
    };
    columns: {
        type: ArrayConstructor;
        required: true;
    };
    fetchRequired: {
        type: BooleanConstructor;
        required: true;
    };
    filterOpen: {
        type: BooleanConstructor;
        required: true;
    };
    focusFilterOnOpen: {
        type: StringConstructor;
        required: true;
    };
    fetchRows: {
        type: FunctionConstructor;
        required: true;
    };
}>> & {
    onFetchRequired?: ((...args: any[]) => any) | undefined;
}, {
    bindToQueryString: boolean;
}>;
export default _sfc_main;
